;=========================================================
; Hammerin' Chuck
; By Erik557
;=========================================================
; Description: A chuck that throws hammers, kinda like the
; pitchin' chuck. It uses the same tilemap as the normal
; chucks.
;
; Uses extra bit: YES
; When it's set, the chuck will throw baseballs when
; running. Else, it will throw them before being hit.
;
; Extra bytes:
; Extra byte 1: the balls will go downwards if 01. 00,
; and they'll go upwards.
;=========================================================

!cust_baseball_num      = $00+$13       ;   change 00 to the slot you used in PIXI

print "INIT ",pc
        LDA !E4,x
        AND #$30
        LSR #4
        STA !187B,x
        LDA #$0A
        STA !C2,x
        %SubHorzPos()
        TYA
        STA !157C,x
        TYX
        LDA.l $018526,x
        LDX $15E9|!Base2
        STA !151C,x
        RTL

DATA_018526:
        db $00,$04
DATA_02C213:
        db $01,$02,$03,$02
DATA_02C228:
        db $40,$10
DATA_02C22A:
        db $03,$01
DATA_02C3B3:
        db $7F,$BF,$FF,$DF
DATA_02C3B7:
        db $18,$19,$14,$14
DATA_02C3BB:
        db $18,$18,$18,$18,$17,$17,$17,$17
        db $17,$17,$16,$15,$15,$16,$16,$16
baseball_x_disp:
        db $10,$F8
DATA_02C462:
        db $00,$FF
baseball_y_speed:
        db $20,$E0
DATA_02C73D:
        db $0A,$0B,$0A,$0C,$0D,$0C
DATA_02C743:
        db $0C,$10,$10,$04,$08,$10,$18

print "MAIN ",pc
        PHB
        PHK
        PLB
        LDA !187B,x
        PHA
        JSR pitchin_chuck_up
        PLA
        BNE +
        CMP !187B,x
        BEQ +
        LDA !163E,x
        BNE +
        LDA #$28
        STA !163E,x
+       PLB
        RTL

not_normal:
        LDA $14
        LSR #2
        AND #$03
        TAY
        LDA DATA_02C213,y
        STA !151C,x
        ;   Satanism
        LDA #$98
        STA !9E,x
        PEA.w ($02)|(pitchin_chuck_up>>16<<8)
        PLB
        PHK
        PEA.w .return-1
        PEA $B888
        JML $02C81A|!BankB
.return
        PLB
        LDA #$36
        STA !9E,x
        RTS

pitchin_chuck_up:
        LDA !14C8,x
        CMP #$08
        BNE not_normal
        LDA !15AC,x
        BEQ +
        LDA #$05
        STA !1602,x
+       LDA !1588,x
        AND #$04
        BNE +
        LDA !AA,x
        BPL +
        LDA !C2,x
        CMP #$05
        BCS +
        LDA #$06
        STA !1602,x
        ;   Satanism
+       LDA #$98
        STA !9E,x
        PEA.w ($02)|(pitchin_chuck_up>>16<<8)
        PLB
        PHK
        PEA.w .return-1
        PEA $B888
        JML $02C81A|!BankB
.return
        LDA #$36
        STA !9E,x
        LDA $9D
        BEQ run_code
        PLB
        RTS

run_code:
        %SubOffScreen()
        PHK
        PEA.w .interact_done-1
        PEA $B888
        JML $02C79D|!BankB
.interact_done
        PLB
        JSL $018032|!BankB
        JSL $019138|!BankB
        LDA !1588,x
        AND #$08
        BEQ +
        LDA #$10
        STA !AA,x
+       LDA !1588,x
        AND #$03
        BEQ .not_touching_objs
        LDA !15A0,x
        ORA !186C,x
        BNE .off_screen
        LDA !187B,x
        BEQ .off_screen
        LDA !E4,x
        SEC
        SBC $1A
        CLC
        ADC #$14
        CMP #$1C
        BCC .off_screen
        LDA !1588,x
        AND #$40
        BNE .off_screen
        LDA $18A7|!Base2
        CMP #$2E
        BEQ +
        CMP #$1E
        BNE .off_screen
+       LDA !1588,x
        AND #$04
        BEQ .air
        PEA.w ($02)|(pitchin_chuck_up>>16<<8)
        PLB
        PEI ($9A)
        PEI ($98)
        JSL $028663|!BankB
        LDA #$02
        STA $9C
        JSL $00BEB0|!BankB
        REP #$20
        PLA
        SEC
        SBC #$0010
        STA $98
        PLA
        STA $9A
        SEP #$20
        JSL $028663|!BankB
        LDA #$02
        STA $9C
        JSL $00BEB0|!BankB
        PLB
        BRA .not_touching_objs

.off_screen
        LDA !1588,x
        AND #$04
        BEQ +
        LDA #$C0
        STA !AA,x
        JSL $01801A|!BankB
        BRA .continue

.not_touching_objs
        JSL $018022|!BankB
.air
+       LDA !1588,x
        AND #$04
        BEQ .continue
        STZ !B6,x       ;\  JSR $02C579
        STZ !AA,x       ;/
.continue
        JSL $01801A|!BankB
        LDY !164A,x
        CPY #$01
        LDY #$00
        LDA !AA,x
        BCC +
        INY
        CMP #$00
        BPL +
        CMP #$E0
        BCS +
        LDA #$E0
+       CLC
        ADC DATA_02C22A,y
        BMI +
        CMP DATA_02C228,y
        BCC +
        LDA DATA_02C228,y
+       TAY
        BMI .execute
        LDY !C2,x
        CPY #$07
        BNE .execute
        CLC
        ADC #$03
.execute
        STA !AA,x
        LDA !C2,x
        JSL $0086DF|!BankB

        dw fuk2
        dw fuk
        dw look_chase
        dw stomp
        dw return
        dw return
        dw return
        dw return
        dw return
        dw return
        dw pitch

fuk:
        PEA.w ($02)|(pitchin_chuck_up>>16<<8)
        PLB
        PHK
        PEA.w .return-1
        PEA $B888
        JML $02C6A7|!BankB
.return
        PLB
        LDA !7FAB10,x
        AND #$04
        BEQ +
        LDA $14
        AND #$1F
        BNE +
        LDA !E4,x
        STA $00
        LDA !14E0,x
        STA $01
        LDA !D8,x
        STA $02
        LDA !14D4,x
        STA $03
        JSR spawn_baseball
+       RTS

fuk2:
        PEA.w ($02)|(pitchin_chuck_up>>16<<8)
        PLB
        PHK
        PEA.w .return-1
        PEA $B888
        JML $02C63B|!BankB
.return
        PLB
        RTS

; MoveItBruh:
        ; %SubVertPos()
        ; RTS
        
pitch:
        LDA !1534,x
        BEQ +
        JMP jumped
; +     JSR MoveItBruh   haha who did this :joy: so funy haha he said bruh sound effect #2 HAHAHAHAHAH comedy!!!!! le bruh---thats how mafia works!!!:joy:
+       %SubVertPos()
        LDA $0F
        BPL .not_jump
        CMP #$D0
        BCS .not_jump
        LDA #$C8
        STA !AA,x
        LDA #$3E
        STA !1540,x
        INC !1534,x
.not_jump
        LDA $13
        AND #$07
        BNE +
        LDA !1540,x
        BEQ +
        INC !1540,x
+       LDA $14
        AND #$3F
        BNE +
        JSR set_direction
+       LDA !1540,x
        BNE +
        LDY !187B,x
        LDA DATA_02C3B3,y
        STA !1540,x
+       LDA !1540,x
        CMP #$40
        BCS +
        STZ !1602,x
        RTS
+       SBC #$40
        LSR #3
        AND #$03
        TAY
        LDA DATA_02C3B7,y
        STA !1602,x
        LDA !1540,x
        AND #$1F
        CMP #$06
        BNE .return
        LDA !E4,x
        STA $00
        LDA !14E0,x
        STA $01
        LDA !D8,x
        STA $02
        LDA !14D4,x
        STA $03
        JSR spawn_baseball
        LDA #$08
        STA !1558,x
.return
        RTS

jumped:
        LDA !1540,x
        BEQ .allow_jumping_again
        PHA
        CMP #$20
        BCC +
        CMP #$30
        BCS +
        STZ !AA,x
+       LSR #2
        TAY
        LDA DATA_02C3BB,y
        STA !1602,x
        PLA
        CMP #$26
        BNE return
        LDA !E4,x
        CLC
        ADC #$10
        STA $00
        LDA !14E0,x
        ADC #$00
        STA $01
        LDA !D8,x
        SEC
        SBC #$10
        STA $02
        LDA !14D4,x
        SBC #$00
        STA $03
        JMP spawn_baseball

.allow_jumping_again
        STZ !1534,x
return:
        RTS

stomp:
        LDY !1570,x
        LDA !1540,x
        BNE +
        INC !1570,x
        INY
        CPY #$07
        BEQ .end_stomp
        LDA DATA_02C743,y
        STA !1540,x
+       LDA DATA_02C73D,y
        STA !1602,x
        LDA #$02
        CPY #$05
        BNE +
        LDA $14
        LSR
        AND #$02
        INC
+       STA !151C,x
        RTS

.end_stomp
        LDA #$30
        STA !1540,x
        LDA #$02
        STA !C2,x
        INC !187B,x
        JMP set_direction

look_chase:
        LDA #$03
        STA !1602,x
        LDA !1540,x
        BNE .return
        LDA #$08        ;\ JSR $02C628
        STA !15AC,x     ;/
        LDA #$01
        STA !C2,x
        LDA #$40
        STA !1540,x
.return
        RTS

spawn_baseball:
        LDA !1558,x
        ORA !186C,x
        BNE .return
        LDY #$07
-       LDA $170B|!Base2,y
        BEQ .spawn
        DEY
        BPL -
.return
        RTS

.spawn
        LDA #!cust_baseball_num
        STA $170B|!Base2,y
        LDA $02
        STA $1715|!Base2,y
        LDA $03
        STA $1729|!Base2,y
        LDA !157C,x
        TAX
        LDA $00
        CLC
        ADC baseball_x_disp,x
        STA $171F|!Base2,y
        LDA $01
        ADC DATA_02C462,x
        STA $1733|!Base2,y
        LDA !7FAB40,x
        TAX
        LDA baseball_y_speed,x
        STA $173D|!Base2,y
        LDX $15E9|!Base2
        RTS

set_direction:
        %SubHorzPos()           ;\
        TYA                     ; |
        STA !157C,x             ; | JSR $02C556
        LDA DATA_018526,y       ; |
        STA !151C,x             ;/
        RTS

